"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const CherrioQuery_1 = require("./CherrioQuery");
const NetworkDriver_1 = require("../fetch/NetworkDriver");
const CheerioUtils_1 = require("./CheerioUtils");
const SelectorsEx_1 = require("../common/SelectorsEx");
let driver;
exports.CheerioDriver = {
    fromHtml(html) {
        return exports.CheerioDriver.build({ html });
    },
    build(config) {
        let html = config.html;
        driver = new CheerioDriverInner(config);
        driver.html = html;
        let el = CheerioUtils_1.CheerioUtils.fromHtml(html);
        let query = new CherrioQuery_1.CherrioQuery(el);
        query.ctx.source = html;
        return query;
    },
    load(url, config) {
        driver = new CheerioDriverInner(config);
        return driver.get(url);
    },
    fetch(url, config, setts) {
        return this.load(url, config, setts);
    },
    setDriver(driver) {
        throw new Error('Cheerio does not support driver');
    },
    getDriver(config, setts) {
        return Promise.resolve(driver);
    },
    unlockDriver(mix) {
        driver = null;
    },
    pseudo: SelectorsEx_1.SelectorsEx.pseudoFns
};
class CheerioDriverInner {
    constructor(config) {
        this.config = config;
    }
    executeScript(script, ...var_args) {
        throw new Error('Method not implemented.');
    }
    executeAsyncScript(script, ...var_args) {
        throw new Error('Method not implemented.');
    }
    get(url) {
        let query = CherrioQuery_1.CherrioQuery.newAsync();
        NetworkDriver_1.NetworkDriver
            .load(url, this.config)
            .then(resp => {
            this.url = resp.url;
            this.headers = resp.headers;
            this.status = resp.status;
            let html = resp.body.toString();
            let $el = CheerioUtils_1.CheerioUtils.fromHtml(html);
            query.add($el);
            query.resolve(query);
        }, error => {
            query.reject(error);
        });
        return query;
    }
    manage() {
        throw new Error('Method not implemented.');
    }
    getCurrentUrl() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.url;
        });
    }
    getPageSource() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.html;
        });
    }
}
