interface ICookie {
    key: string;
    value: string;
    rawOptions?: string;
}
declare class DomainCookies {
    domain: string;
    arr: ICookie[];
    constructor(domain: string);
    add(mix: string | string[] | {
        [key: string]: string;
    }, opts?: {
        extend: boolean;
    }): void;
    stringify(): string;
    private push;
    private static parse;
    private static parseSingle;
}
export declare class CookieContainer {
    domains: {
        [domain: string]: DomainCookies;
    };
    addCookies(cookies: string | string[] | {
        [key: string]: string;
    }): any;
    addCookies(url: string, cookies: string | string[] | {
        [key: string]: string;
    }): any;
    addCookies(url: string, cookies: string | string[] | {
        [key: string]: string;
    }, opts: {
        extend: boolean;
    }): any;
    clearCookies(): void;
    getCookies(url?: string): string;
    private getDomain;
}
export declare const cookieContainer: CookieContainer;
export {};
