/// <reference types="node" />
import { IQuery } from "../common/IQuery";
import { CookieContainer } from './CookieContainer';
export interface IBuildConfig {
    name?: string;
    args?: string[];
    binaryPath?: string;
    applyOptions?(builder: any, options: any): any;
    setOptions?(builder: any, options: any): any;
    setArguments?(options: any): any;
    setBinaryPath?(options: any): any;
    setLogging?(options: any): any;
    headers?: {
        [name: string]: string;
    };
    method?: 'post' | 'get' | 'delete' | 'patch' | 'head' | string;
    query?: {
        [name: string]: string;
    };
    body?: string | Buffer;
    cookies?: {
        [name: string]: string;
    } | string[] | string;
    cookiesDefault?: {
        [name: string]: string;
    } | string[] | string;
    cache?: boolean | {
        folder?: string;
        maxAge?: number;
        compress?: boolean;
    };
    cacheQueryIgnore?: string[];
    /** Webdriver will load this url, or requested url, to set the cookies first */
    cookieOrigin?: string;
    cookieContainer?: CookieContainer;
    [key: string]: any;
}
export interface ILoadConfig extends IBuildConfig {
    retryCount?: number;
    retryTimeout?: number;
    follow?: number;
    httpsProxy?: string;
}
export interface ISettings {
    pool?: boolean | number;
    query?: IQuery<any>;
    opts?: any;
}
