import { class_Dfr } from 'atma-utils';
import { Deferred } from '../types/Deferred';
export declare class IQueryCtx {
    owner: IQuery<any>;
    self: IQuery<any>;
    source: string;
    thener: (resolve: any, reject: any) => IQuery<any>;
    Ctor: new (mix?: any) => IQuery<any>;
    newSync(arr?: any, parent?: IQuery<any>): IQuery<any>;
    newAsync(arr?: any, parent?: IQuery<any>): IQuery<any>;
}
export declare abstract class IQuery<TElement> extends class_Dfr implements PromiseLike<any> {
    [index: number]: TElement;
    length: number;
    ctx: IQueryCtx;
    constructor(mix?: any);
    ensureSync(): IQuery<TElement>;
    ensureAsync(): IQuery<TElement>;
    resolve(...args: any[]): this;
    wait(ms: any): Promise<unknown>;
    hasClass(name: string): PromiseLike<boolean>;
    protected abstract hasClassFn(node: TElement, name: string): Deferred<boolean>;
    addClass(name: string): IQuery<any>;
    protected abstract addClassFn(node: TElement, name: string): Deferred<void>;
    removeClass(name: string): IQuery<TElement>;
    protected abstract removeClassFn(node: TElement, name: string): Deferred<void>;
    toggleClass(name: string): IQuery<TElement>;
    protected abstract toggleClassFn(node: TElement, name: string): Deferred<void>;
    add(mix: any): any;
    eq(index: any): IQuery<any>;
    slice(start?: number, end?: number): IQuery<any>;
    each(fn: any): IQuery<any>;
    map(fn: any): IQuery<any>;
    toArray(): Deferred<unknown>;
    text(): PromiseLike<string>;
    text(str: string): IQuery<TElement>;
    protected abstract textGetFn(node: TElement): Deferred<string>;
    protected abstract textSetFn(node: TElement, text: string): Deferred<void>;
    html(): PromiseLike<string>;
    html(str: string): IQuery<TElement>;
    outerHtml(): PromiseLike<string>;
    protected abstract htmlGetFn(node: TElement): Deferred<string>;
    protected abstract htmlOuterGetFn(node: TElement): Deferred<string>;
    protected abstract htmlSetFn(node: TElement, text: string): Deferred<void>;
    append(html: string): IQuery<TElement>;
    protected abstract appendFn(node: TElement, html: string): Deferred<void>;
    prepend(html: string): IQuery<any>;
    protected abstract prependFn(node: TElement, html: string): Deferred<void>;
    before(html: string): IQuery<any>;
    protected abstract beforeFn(node: TElement, html: string): Deferred<void>;
    after(html: string): IQuery<any>;
    protected abstract afterFn(node: TElement, html: string): Deferred<void>;
    css(cssObj: {
        [key: string]: any;
    }): IQuery<TElement>;
    css(key: string, val: any): IQuery<TElement>;
    css(key: string): Promise<any>;
    protected abstract cssGet(node: TElement, prop: string): Promise<any>;
    protected abstract cssSet(node: TElement, css: {
        [key: string]: any;
    }): Deferred<void>;
    height(): Promise<number>;
    height(val: any): IQuery<TElement>;
    protected abstract heightGetFn(node: TElement): Promise<number>;
    innerHeight(): PromiseLike<number>;
    protected abstract innerHeightFn(node: TElement): Promise<number>;
    width(): Promise<number>;
    width(val: any): IQuery<TElement>;
    protected abstract widthGetFn(node: TElement): Promise<number>;
    innerWidth(): PromiseLike<number>;
    protected abstract innerWidthFn(node: TElement): Promise<number>;
    offset(): Promise<{
        top: number;
        left: number;
    }>;
    protected abstract getBoundingClientRect(node: TElement): Promise<{
        top: number;
        left: number;
        width: number;
        height: number;
    }>;
    position(): Promise<{
        top: number;
        left: number;
    }>;
    protected abstract getPosition(node: TElement): Promise<{
        top: number;
        left: number;
    }>;
    scrollTop(): Promise<number>;
    scrollTop(scroll: number): IQuery<TElement>;
    protected abstract scrollTopGetFn(node: TElement): Promise<number>;
    protected abstract scrollTopSetFn(node: TElement, scroll: number): Deferred<void>;
    scrollLeft(): Promise<number>;
    scrollLeft(scroll: number): IQuery<TElement>;
    protected abstract scrollLeftGetFn(node: TElement): Promise<number>;
    protected abstract scrollLeftSetFn(node: TElement, scroll: number): Deferred<void>;
    eval(mix: Function | string, ...args: any[]): Promise<any>;
    protected abstract evalFn(node: TElement, mix: Function | string, ...args: any[]): Promise<any>;
    click(): IQuery<TElement>;
    protected abstract clickFn(node: TElement): Promise<void>;
    trigger(type: any, ...args: any[]): IQuery<TElement>;
    protected abstract triggerFn(node: TElement, type: string, ...args: any[]): Promise<void>;
    select(...args: any[]): IQuery<TElement>;
    protected abstract selectFn(node: TElement, ...args: any[]): Promise<void>;
    focus(): IQuery<TElement>;
    protected abstract focusFn(node: TElement): Promise<void>;
    blur(): IQuery<TElement>;
    protected abstract blurFn(node: TElement): Promise<void>;
    sendKeys(mix: any): IQuery<TElement>;
    protected abstract sendKeysFn(node: TElement, mix: any): Promise<void>;
    type(str: any): IQuery<TElement>;
    protected abstract typeFn(node: TElement, str: string): Promise<void>;
    press(str: any): IQuery<TElement>;
    protected abstract pressFn(node: TElement, str: string): Promise<void>;
    remove(): IQuery<TElement>;
    protected abstract removeFn(node: TElement): Promise<void>;
    attr(name: string): Promise<any>;
    attr(vals: {
        [key: string]: any;
    }): IQuery<TElement>;
    attr(key: string, val: any): IQuery<TElement>;
    protected abstract attrGetFn(node: TElement, prop: string): Promise<any>;
    protected abstract attrSetFn(node: TElement, attr: {
        [key: string]: any;
    }): Deferred<void>;
    val(): PromiseLike<any>;
    val(val: any): IQuery<TElement>;
    protected abstract valGetFn(node: TElement): Promise<any>;
    protected abstract valSetFn(node: TElement, value: any): Deferred<void>;
    data(key: string): PromiseLike<any>;
    data(key: string, val: any): IQuery<TElement>;
    data(dataObj: {
        [key: string]: any;
    }): IQuery<TElement>;
    protected abstract dataGetFn(node: TElement, key: string): Promise<any>;
    protected abstract dataSetFn(node: TElement, data: object): Deferred<void>;
    prop(key: string): PromiseLike<any>;
    prop(key: string, val: any): IQuery<TElement>;
    prop(obj: {
        [key: string]: any;
    }): IQuery<TElement>;
    protected abstract propGetFn(node: TElement, key: string): Promise<any>;
    protected abstract propSetFn(node: TElement, data: object): Deferred<void>;
    find(sel: string): IQuery<TElement>;
    protected abstract findFn(node: TElement, selector: string): Deferred<TElement[]>;
    filter(fn: (node: TElement) => boolean | Promise<boolean>): IQuery<TElement>;
    filter(sel: string): IQuery<TElement>;
    protected abstract matchesFn(node: TElement, selector: string): Promise<boolean>;
    parent(): IQuery<TElement>;
    protected abstract parentFn(node: TElement): Promise<TElement>;
    closest(sel: string): IQuery<TElement>;
    protected abstract closestFn(node: TElement, sel: string): Promise<TElement>;
    children(sel?: string): IQuery<TElement>;
    protected abstract childrenFn(node: TElement, sel?: string): Promise<TElement[]>;
    next(sel?: string): IQuery<TElement>;
    protected abstract nextFn(node: TElement, sel?: string): Promise<TElement>;
    protected abstract getField<T>(node: TElement, field: string): Deferred<T>;
    protected abstract setField(node: TElement, obj: any): Deferred<void>;
    protected abstract setField(node: TElement, field: string, val: any): Deferred<void>;
    protected abstract callField<T>(node: TElement, field: string, ...args: any[]): Deferred<T>;
    on(type: string, cb: (el: TElement) => void): IQuery<any>;
    off(type: string, cb: Function): IQuery<any>;
    once(type: string, cb?: (event: any) => void): IQuery<any>;
    protected abstract _onFn(node: TElement, type: string, cb: Function): Promise<any>;
    protected abstract _onOnceFn(node: TElement, type: string, cb: Function): Promise<any>;
    protected abstract _offFn(node: TElement, type: string, cb: Function): Promise<any>;
}
