"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
let rgx_PSEUDO = /:([\w]+)(\s*\(([^)]+)\))?/g;
var SelectorsEx;
(function (SelectorsEx) {
    SelectorsEx.pseudoFns = {};
    function register(name, fn) {
        SelectorsEx.pseudoFns[name] = fn;
    }
    SelectorsEx.register = register;
    function find(el, selector, find) {
        let query = el.ctx.newAsync();
        findInner(el, selector, find).then($ => {
            query.resolve($);
        }, error => {
            query.reject(error);
        });
        return query;
    }
    SelectorsEx.find = find;
    function findInner(el, selector, find) {
        return __awaiter(this, void 0, void 0, function* () {
            rgx_PSEUDO.lastIndex = -1;
            let $ = el;
            do {
                let match = rgx_PSEUDO.exec(selector);
                if (match == null) {
                    break;
                }
                let [_, name, _g2, arg] = match;
                if (name in SelectorsEx.pseudoFns === false) {
                    continue;
                }
                let selectorBefore = selector.substring(0, match.index);
                if (selectorBefore.length > 0) {
                    $ = yield find($, selectorBefore);
                    if ($.length === 0) {
                        return $;
                    }
                }
                selector = selector.substring(match.index + match[0].length);
                let fn = SelectorsEx.pseudoFns[name];
                $ = yield fn($, arg);
            } while (selector.length > 0);
            if (selector.length > 0) {
                return find($, selector);
            }
            return $;
        });
    }
})(SelectorsEx = exports.SelectorsEx || (exports.SelectorsEx = {}));
