"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const atma_utils_1 = require("atma-utils");
var Body;
(function (Body) {
    function handleAsRawObject(opts) {
        var _a, _b, _c;
        let mime = (_b = (_a = opts.headers) === null || _a === void 0 ? void 0 : _a['content-type'], (_b !== null && _b !== void 0 ? _b : (_c = opts.headers) === null || _c === void 0 ? void 0 : _c['Content-Type']));
        if (mime == null) {
            mime = 'application/json; charset=UTF-8';
            opts.headers = atma_utils_1.obj_extend(opts.headers, {
                'Content-Type': mime
            });
        }
        if (mime.includes('/json')) {
            opts.body = JSON.stringify(opts.body);
            return;
        }
        if (mime.includes('form-urlencoded')) {
            const { URLSearchParams } = require('url');
            const params = new URLSearchParams();
            const obj = flatternObject(opts.body);
            for (let key in obj) {
                params.append(key, obj[key]);
            }
            opts.body = params;
            return;
        }
        if (mime.includes('form-data')) {
            const FormData = require('form-data');
            const form = new FormData();
            const obj = flatternObject(opts.body);
            for (let key in obj) {
                form.append(key, obj[key]);
            }
            opts.body = form;
            return;
        }
    }
    Body.handleAsRawObject = handleAsRawObject;
    function flatternObject(obj, out = {}, prfx = null) {
        for (let key in obj) {
            let val = obj[key];
            if (val == null) {
                continue;
            }
            let path = prfx ? `${prfx}[${key}]` : key;
            if (typeof val !== 'object') {
                out[path] = val;
                continue;
            }
            if (Array.isArray(val)) {
                val.forEach((x, index) => {
                    flatternObject(x, out, `${path}[${index}]`);
                });
                return;
            }
            if (atma_utils_1.is_rawObject(val)) {
                flatternObject(val, out, path);
                return;
            }
            throw new Error(`Cannt flattern object. Unsupported value type in ${path}`);
        }
        return out;
    }
})(Body = exports.Body || (exports.Body = {}));
