import { ILoadConfig } from '../common/IConfig';
import { NetworkResponse } from './NetworkDriver';
interface ICacheItem {
    time: number;
    file: string;
    maxAge: number;
}
export declare class Cache {
    meta: {
        [domainKey: string]: {
            [url: string]: ICacheItem;
        };
    };
    private hasInner;
    has(url: string, config?: ILoadConfig): boolean;
    hasAsync(url: string, config?: ILoadConfig): Promise<boolean>;
    remove(url: string, config: ILoadConfig): any;
    get(url: string, config: ILoadConfig): Promise<any>;
    save(url: string, config: ILoadConfig, resp: NetworkResponse): any;
    private normalizeUrl;
    private ensureMeta;
    isFlushDeferred: boolean;
    private flushMeta;
}
export declare const cache: Cache;
export {};
