import { ILoadConfig } from "../common/IConfig";
export declare const NetworkDriver: {
    isCached(url: string, config?: ILoadConfig): boolean;
    isCachedAsync(url: string, config?: ILoadConfig): Promise<boolean>;
    clearCookies(): void;
    clearCached(url: string, config?: ILoadConfig): void;
    load(url: string, config?: ILoadConfig): Promise<NetworkResponse>;
    getCookies(url?: string): string;
    setCookies: {
        (cookies: string | string[] | {
            [key: string]: string;
        }): any;
        (url: string, cookies: string | string[] | {
            [key: string]: string;
        }): any;
        (url: string, cookies: string | string[] | {
            [key: string]: string;
        }, opts: {
            extend: boolean;
        }): any;
    };
};
export interface NetworkResponse {
    status: number;
    message?: string;
    headers: {
        [name: string]: string;
    };
    url: string;
    body: any;
}
