import { IDriver } from "../common/IDriver";
import { IBuildConfig, ILoadConfig, ISettings } from "../common/IConfig";
import { class_Dfr } from "atma-utils";
import { IQuery } from "../common/IQuery";
import { WebdriverQuery } from "./WebdriverQuery";
export declare class DriverPool {
    singleton: DriverWrapper;
    singletonPromise: Promise<DriverWrapper>;
    pool: DriverWrapper[];
    queue: {
        url: string;
        config: ILoadConfig;
        dfr: class_Dfr;
    }[];
    get(url: string, config: ILoadConfig, setts: ISettings): Promise<DriverWrapper>;
    getWithDomain(url: string, config: ILoadConfig, setts: ISettings): Promise<DriverWrapper>;
    unlockDriver(mix: IQuery<any> | IDriver | DriverWrapper): Promise<void>;
    private getGlobal;
    extractDriver(query: WebdriverQuery): IDriver;
    private requestDriver;
    private memCookies;
    setGlobal(driver: IDriver): any;
}
export declare class DriverWrapper {
    requestedAt: Date;
    busy: boolean;
    driver: IDriver;
    cookies: string;
    build(config: IBuildConfig): Promise<void>;
    ensureCookies(url: string, config: ILoadConfig): Promise<void>;
}
export declare const driverPool: DriverPool;
