"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const node_1 = require("./utils/node");
var WebdriverEventsPoll;
(function (WebdriverEventsPoll) {
    let bin = [];
    let ids = {};
    function addEventListener(node, type, cb) {
        return node_1.node_eval(node, scripts_addEventListener, type).then(id => {
            bin.push([node, type, cb, id]);
            ids[id] = { node, type, cb, active: true };
            function poll() {
                return __awaiter(this, void 0, void 0, function* () {
                    let data = ids[id];
                    if (data.active !== true) {
                        return;
                    }
                    let event = yield node_1.node_eval(node, scripts_pollEvent, id);
                    if (data.active !== true) {
                        return;
                    }
                    if (event) {
                        cb(event);
                        poll();
                        return;
                    }
                    setTimeout(poll, 200);
                });
            }
            poll();
        });
    }
    WebdriverEventsPoll.addEventListener = addEventListener;
    function removeEventListener(node, type, cb = null) {
        return __awaiter(this, void 0, void 0, function* () {
            for (let i = 0; i < bin.length; i++) {
                let data = bin[i];
                let [_node, _type, _cb, _id] = data;
                if (type !== _type) {
                    continue;
                }
                if (node !== _node) {
                    continue;
                }
                if (cb != null && cb !== _cb) {
                    continue;
                }
                let info = ids[_id];
                if (info) {
                    info.active = false;
                }
                yield node_1.node_eval(node, scripts_removeEventListener, _id);
                bin.splice(i, 1);
                delete ids[_id];
                i--;
            }
        });
    }
    WebdriverEventsPoll.removeEventListener = removeEventListener;
})(WebdriverEventsPoll = exports.WebdriverEventsPoll || (exports.WebdriverEventsPoll = {}));
